diff -ruN --exclude=*.obj --exclude=*.py* --exclude=*.manifest --exclude=Makefile --exclude=*.exp --exclude=*.lib h:\Incoming\sip-4.4.3/doc/sipref.html ./doc/sipref.html
--- h:\Incoming\sip-4.4.3/doc/sipref.html	Thu Apr 27 08:08:20 2006
+++ ./doc/sipref.html	Sun May  7 18:22:46 2006
@@ -1053,6 +1053,9 @@
 <td>The suffix to use for generated C or C++ source files.  By default
 <tt class="docutils literal"><span class="pre">.c</span></tt> is used for C and <tt class="docutils literal"><span class="pre">.cpp</span></tt> for C++.</td></tr>
 <tr><td>
+<kbd><span class="option">-p</span> <var>header</var></kbd></td>
+<td>Pre-compiled header file to include first.  By default none.</td></tr>
+<tr><td>
 <kbd><span class="option">-t</span> <var>tag</var></kbd></td>
 <td>The SIP version tag (declared using a <a class="reference" href="#timeline">%Timeline</a> directive) or the
 SIP platform tag (declared using the <a class="reference" href="#platforms">%Platforms</a> directive) to
diff -ruN --exclude=*.obj --exclude=*.py* --exclude=*.manifest --exclude=Makefile --exclude=*.exp --exclude=*.lib h:\Incoming\sip-4.4.3/doc/sipref.txt ./doc/sipref.txt
--- h:\Incoming\sip-4.4.3/doc/sipref.txt	Thu Apr 27 08:08:12 2006
+++ ./doc/sipref.txt	Sun May  7 18:20:55 2006
@@ -837,6 +837,8 @@
 -s suffix
         The suffix to use for generated C or C++ source files.  By default
         ``.c`` is used for C and ``.cpp`` for C++.
+-p header
+        pre-compiled header to include first [default none]
 -t tag  The SIP version tag (declared using a `%Timeline`_ directive) or the
         SIP platform tag (declared using the `%Platforms`_ directive) to
         generate code for.  This option may be given any number of times so
diff -ruN --exclude=*.obj --exclude=*.py* --exclude=*.manifest --exclude=Makefile --exclude=*.exp --exclude=*.lib h:\Incoming\sip-4.4.3/sipgen/gencode.c ./sipgen/gencode.c
--- h:\Incoming\sip-4.4.3/sipgen/gencode.c	Thu Apr 27 08:08:08 2006
+++ ./sipgen/gencode.c	Sun May  7 18:54:40 2006
@@ -63,7 +63,7 @@
 static void generateBuildFile(sipSpec *,char *,char *,int);
 static void generateInternalAPIHeader(sipSpec *,char *,stringList *);
 static void generateCpp(sipSpec *,char *,char *,int *);
-static void generateIfaceCpp(sipSpec *,ifaceFileDef *,char *,char *,FILE *);
+static void generateIfaceCpp(sipSpec *,ifaceFileDef *,char *,char *,char *,FILE *);
 static void generateMappedTypeCpp(mappedTypeDef *,FILE *);
 static void generateImportedMappedTypeHeader(mappedTypeDef *mtd,sipSpec *pt,
 					     FILE *fp);
@@ -195,7 +195,7 @@
  * Generate the code from a specification.
  */
 void generateCode(sipSpec *pt,char *codeDir,char *buildfile,char *docFile,
-		  char *apiFile,char *srcSuffix,int except,int trace,
+		  char *apiFile,char *srcSuffix,char *pch, int except,int trace,
 		  int releaseGIL,int parts,stringList *xsl)
 {
 	exceptions = except;
@@ -213,7 +213,7 @@
 	/* Generate the code. */
 	if (codeDir != NULL)
 	{
-		generateCpp(pt,codeDir,srcSuffix,&parts);
+		generateCpp(pt,codeDir,srcSuffix,pch,&parts);
 		generateInternalAPIHeader(pt,codeDir,xsl);
 	}
 
@@ -731,7 +731,7 @@
 /*
  * Generate the C/C++ code.
  */
-static void generateCpp(sipSpec *pt,char *codeDir,char *srcSuffix,int *parts)
+static void generateCpp(sipSpec *pt,char *codeDir,char *srcSuffix,char *pch,int *parts)
 {
 	char *cppfile, *mname = pt -> module -> name;
 	int noIntro, nrSccs = 0, files_in_part, max_per_part, this_part;
@@ -768,6 +768,13 @@
 
 	fp = createFile(pt,cppfile,"Module code.");
 
+	if (pch != NULL)
+		prcode(fp,
+"\n"
+"#include \"%s\"\n"
+"\n"
+			,pch);
+
 	prcode(fp,
 "\n"
 "#include \"sipAPI%s.h\"\n"
@@ -1686,7 +1693,7 @@
 				fp = createFile(pt,cppfile,"Module code.");
 			}
 
-			generateIfaceCpp(pt,iff,codeDir,srcSuffix,(*parts ? fp : NULL));
+			generateIfaceCpp(pt,iff,codeDir,srcSuffix,pch,(*parts ? fp : NULL));
 		}
 
 		generateIfaceHeader(pt,iff,codeDir);
@@ -2653,7 +2660,7 @@
  * Generate the C/C++ code for an interface.
  */
 static void generateIfaceCpp(sipSpec *pt,ifaceFileDef *iff,char *codeDir,
-			     char *srcSuffix,FILE *master)
+			     char *srcSuffix,char *pch,FILE *master)
 {
 	char *cppfile, *cmname = iff -> module -> name;
 	classDef *cd;
@@ -2668,6 +2675,13 @@
 	else
 		fp = master;
 
+	if (pch != NULL)
+		prcode(fp,
+		"\n"
+		"#include \"%s\"\n"
+		"\n"
+		,pch);
+
 	prcode(fp,
 "\n"
 "#include \"sipAPI%s.h\"\n"
diff -ruN --exclude=*.obj --exclude=*.py* --exclude=*.manifest --exclude=Makefile --exclude=*.exp --exclude=*.lib h:\Incoming\sip-4.4.3/sipgen/main.c ./sipgen/main.c
--- h:\Incoming\sip-4.4.3/sipgen/main.c	Thu Apr 27 08:08:08 2006
+++ ./sipgen/main.c	Sun May  7 18:43:07 2006
@@ -48,7 +48,7 @@
 
 int main(int argc,char **argv)
 {
-	char *filename, *docFile, *codeDir, *srcSuffix, *flagFile;
+	char *filename, *docFile, *codeDir, *srcSuffix, *flagFile, *pch;
 	char arg, *optarg, *buildFile, *apiFile;
 	int optnr, exceptions, tracing, releaseGIL, parts;
 	FILE *file;
@@ -63,6 +63,7 @@
 	buildFile = NULL;
 	codeDir = NULL;
 	docFile = NULL;
+	pch = NULL;
 	srcSuffix = NULL;
 	flagFile = NULL;
 	apiFile = NULL;
@@ -74,7 +75,7 @@
 	/* Parse the command line. */
 	optnr = 1;
 
-	while ((arg = parseopt(argc,argv,"hVa:b:ec:d:gI:j:rs:t:wx:z:",&flagFile,&optnr,&optarg)) != '\0')
+	while ((arg = parseopt(argc,argv,"hVa:b:ec:d:gI:j:rs:p:t:wx:z:",&flagFile,&optnr,&optarg)) != '\0')
 		switch (arg)
 		{
 		case 'a':
@@ -145,6 +146,11 @@
 			srcSuffix = optarg;
 			break;
 
+		case 'p':
+			/* Pre-compiled header. */
+			pch = optarg;
+			break;
+
 		case 'w':
 			/* Enable warning messages. */
 			warnings = TRUE;
@@ -188,7 +194,7 @@
 	transform(&spec);
 
 	/* Generate code. */
-	generateCode(&spec,codeDir,buildFile,docFile,apiFile,srcSuffix,
+	generateCode(&spec,codeDir,buildFile,docFile,apiFile,srcSuffix,pch,
 		     exceptions,tracing,releaseGIL,parts,xfeatures);
 
 	/* All done. */
@@ -452,6 +458,7 @@
 "    -j #        split the generated code into # files [default 1 per class]\n"
 "    -r          generate code with tracing enabled [default disabled]\n"
 "    -s suffix   the suffix to use for C or C++ source files [default \".c\" or \".cpp\"]\n"
+"    -p header   pre-compiled header to include first [default none]\n"
 "    -t tag      the version/platform to generate code for\n"
 "    -w          enable warning messages\n"
 "    -x feature  this feature is disabled\n"
Binary files h:\Incoming\sip-4.4.3/sipgen/sip.exe and ./sipgen/sip.exe differ
diff -ruN --exclude=*.obj --exclude=*.py* --exclude=*.manifest --exclude=Makefile --exclude=*.exp --exclude=*.lib h:\Incoming\sip-4.4.3/sipgen/sip.h ./sipgen/sip.h
--- h:\Incoming\sip-4.4.3/sipgen/sip.h	Thu Apr 27 08:08:08 2006
+++ ./sipgen/sip.h	Sun May  7 18:15:51 2006
@@ -933,7 +933,7 @@
 void parse(sipSpec *,FILE *,char *,stringList *,stringList *);
 void parserEOF(char *,parserContext *);
 void transform(sipSpec *);
-void generateCode(sipSpec *,char *,char *,char *,char *,char *,int,int,int,int,stringList *);
+void generateCode(sipSpec *,char *,char *,char *,char *,char *,char *,int,int,int,int,stringList *);
 void warning(char *,...);
 void fatal(char *,...);
 void fatalScopedName(scopedNameDef *);